// Code generated by sqlc. DO NOT EDIT.
// source: budgets.sql

package postgres

import (
	"context"
)

const createBudget = `-- name: CreateBudget :one
INSERT INTO budgets
(id, name, last_modification)
VALUES ($1, $2, NOW())
RETURNING id, name, last_modification
`

type CreateBudgetParams struct {
	ID   string
	Name string
}

func (q *Queries) CreateBudget(ctx context.Context, arg CreateBudgetParams) (Budget, error) {
	row := q.db.QueryRow(ctx, createBudget, arg.ID, arg.Name)
	var i Budget
	err := row.Scan(&i.ID, &i.Name, &i.LastModification)
	return i, err
}

const getBudgetsForUser = `-- name: GetBudgetsForUser :many
SELECT budgets.id, budgets.name, budgets.last_modification FROM budgets 
LEFT JOIN user_budgets ON budgets.id = user_budgets.budget_id
WHERE user_budgets.user_id = $1
`

func (q *Queries) GetBudgetsForUser(ctx context.Context, userID string) ([]Budget, error) {
	rows, err := q.db.Query(ctx, getBudgetsForUser, userID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Budget
	for rows.Next() {
		var i Budget
		if err := rows.Scan(&i.ID, &i.Name, &i.LastModification); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
